"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._testLoad = exports.AwaitLoader = void 0;
var tslib_1 = require("tslib");
var React = tslib_1.__importStar(require("react"));
var withLoader_1 = require("./withLoader");
var R = React;
/**
 * @typedef AwaitLoaderProps
 * @type {Object}
 * @property {Types.Loader<TProps, TReturn, any, any, any, TArg>} loader The loader to use.
 * @property {(data: TReturn) => React.ReactElement} render The render function to use.
 * @property {TProps} args The arguments to pass to the loader.
 */
/**
 * A component that awaits a loader and renders the data.
 * @param {AwaitLoaderProps} args The arguments to pass to the loader.
 */
var AwaitLoader = function (args) {
    var Component = R.useCallback((0, withLoader_1.withLoader)(function (_, loaderData) { return args.render(loaderData); }, args.loader), []);
    return R.createElement(Component, "args" in args ? args.args : {}, null);
};
exports.AwaitLoader = AwaitLoader;
var _testLoad = function (react) {
    R = react;
    return exports.AwaitLoader;
};
exports._testLoad = _testLoad;
//# sourceMappingURL=AwaitLoader.js.map