import * as React from "react";
import { withLoader } from "./withLoader";
var R = React;
/**
 * @typedef AwaitLoaderProps
 * @type {Object}
 * @property {Types.Loader<TProps, TReturn, any, any, any, TArg>} loader The loader to use.
 * @property {(data: TReturn) => React.ReactElement} render The render function to use.
 * @property {TProps} args The arguments to pass to the loader.
 */
/**
 * A component that awaits a loader and renders the data.
 * @param {AwaitLoaderProps} args The arguments to pass to the loader.
 */
export var AwaitLoader = function (args) {
    var Component = R.useCallback(withLoader(function (_, loaderData) { return args.render(loaderData); }, args.loader), []);
    return R.createElement(Component, "args" in args ? args.args : {}, null);
};
export var _testLoad = function (react) {
    R = react;
    return AwaitLoader;
};
//# sourceMappingURL=AwaitLoader.js.map