import * as Types from "./types";
/**
 * Creates a query from an async getter function.
 * @param getter The async function to get the data.
 * @param dependencies The dependency array to watch for changes.
 * @example
 * const query = useCreateQuery(async () => {
 *  const response = await fetch(`/users/${userId}`);
 *  return response.json();
 * }, [userId]);
 */
export declare const useCreateQuery: <T extends unknown>(getter: Types.CreateQueryGetter<T>, dependencies?: any[]) => Types.UseQueryResult<T>;
export declare const _testCreateUseCreateQuery: (react: any) => <T extends unknown>(getter: Types.CreateQueryGetter<T>, dependencies?: any[]) => Types.UseQueryResult<T>;
